﻿Public Class Form1
    Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vkey As Int32) As Short

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Enabled = True
        Timer1.Interval = 1
    End Sub
    Private Sub MoveCursor()

        Dim calcX As Double = CDbl(Cursor.Position.X)
        Dim calcY As Double = CDbl(Cursor.Position.Y)
        Dim calcRadius As Double = Math.Sqrt(Math.Pow((calcX - GlobalVariables.centerX), 2) + Math.Pow((calcY + GlobalVariables.centerY), 2))
        If (calcRadius >= GlobalVariables.Radius) Then
            Dim newSize As Size = New Size(GlobalVariables.Radius, GlobalVariables.Radius)
            Dim centerPoint As Point = New Point(GlobalVariables.centerX, GlobalVariables.centerY)
            Dim newPoint As Point = New Point(GlobalVariables.centerX - (GlobalVariables.Radius / 2), GlobalVariables.centerY - (GlobalVariables.Radius / 2))
            Cursor.Clip = New Rectangle(newPoint, newSize)
        End If
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim ESCkey As Boolean
        Dim ShiftKey As Boolean
        Dim CtrlKey As Boolean
        Dim AltKey As Boolean
        Dim sKey As Boolean
        ESCkey = GetAsyncKeyState(Keys.Escape)
        ShiftKey = GetAsyncKeyState(Keys.ShiftKey)
        CtrlKey = GetAsyncKeyState(Keys.ControlKey)
        AltKey = GetAsyncKeyState(Keys.Menu)
        sKey = GetAsyncKeyState(Keys.S)
        If (ESCkey) Then
            GlobalVariables.CenterFound = False
        End If
        If (sKey AndAlso (CtrlKey AndAlso ShiftKey AndAlso AltKey)) Then
            GlobalVariables.CenterFound = True
            GlobalVariables.centerX = CDbl(Cursor.Position.X)
            GlobalVariables.centerY = CDbl(Cursor.Position.Y)
            GlobalVariables.Saved = True
        End If
        If (sKey AndAlso (CtrlKey AndAlso Not ShiftKey AndAlso AltKey)) Then
            GlobalVariables.CenterFound = True
        End If
        If (GlobalVariables.CenterFound) Then
            MoveCursor()
        Else
            Cursor.Clip = Rectangle.Empty
        End If

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        GlobalVariables.Radius = CDbl(RadiusInput.Text)
    End Sub

    Private Sub BtnReset_Click(sender As Object, e As EventArgs) Handles BtnReset.Click
        If (GlobalVariables.CenterFound = False AndAlso GlobalVariables.Saved = True) Then
            GlobalVariables.Saved = False
            GlobalVariables.centerX = -1
            GlobalVariables.centerY = -1
            MessageBox.Show("Location has been reset!", "Location Reset")
        End If
    End Sub

    Private Sub BtnGoTo_Click(sender As Object, e As EventArgs) Handles BtnGoTo.Click
        If (GlobalVariables.Saved) Then
            GlobalVariables.CenterFound = True
        Else
            MessageBox.Show("You don't have a saved location!", "User Error")
        End If
    End Sub
End Class
Public Class GlobalVariables
    Public Shared Property CenterFound As Boolean = False
    Public Shared Property Saved As Boolean = False
    Public Shared Property Radius As Double = 50
    Public Shared Property centerX As Double = -1
    Public Shared Property centerY As Double = -1
End Class